/*
;------------------------------------------------------------------------
; Author:	Jaquet C.		15/05/2000
;
; Project:      Kameleon376SBC
; Goal:		Test MMA communication between two systems.
;------------------------------------------------------------------------
*/

#include	<sys/kos.h>
#include 	<stdlib.h>
#include 	<stdio.h>
#include	<string.h>

/*
 * Process 0 - This process changes the state of the LED 0 every 500ms
 */
 
static void process_0 ()
{
  for (;;)
    {
      tim_suspend_task (5000);
      var_change_led (0);
    }
}

/*
 * Process 1
 */

#define 	kMaxRecBuf 	50

void process_1()
{
	uint8 	RecBuf[kMaxRecBuf];
	uint8	*SndBuf;
	uint8	i = 0;

	uint8 	*Cmd;
		
	uint32 	status = 0;
		
	printf("Test communication between two system via MMA channel \r\n");
	printf("----------------------------------------------------- \r\n\n");
	printf("The Led number 2 on the slave card must blink  every  \r\n");
	printf("two seconds.					      \r\n");

 	RESERVE_MMA0;

	
	for (;;)
	{
	tim_suspend_task(2000);
	SndBuf = "L,1,2\n\r";

	status = mma_send_buffer_0(SndBuf, strlen(SndBuf));
	
	printf("Message sent : %s\n\r", SndBuf);
		do
		{
			status = mma_receive_byte_0();
			if (status != -1)
			{
				RecBuf[i++] = (char)status;
		
				if (((char)status != '\n') & ((char)status != '\r'))
				  printf("Received char(s) %2li . . . %c \r\n", i, (char)status);
				else
				  printf("Received char(s) %2li . . . CR or LF\r\n");
			
			}
		} while (status != '\n');
		RecBuf[i] = '\0';
		printf("\nComplete buffer is : %s \r\n", RecBuf);

	i = 0;


	}	
	RELEASE_MMA0;
	kill_task(tim_get_id());
}

/*
 * MAIN
 *
 * - Initialise the used managers: tim & bios are initialised at the start-up.
 * - Launch all the processes.
 * - Kill the "main". At this moment only the launched processes are executed.
 */

void main(void)
{
	uint32	vIDProcess[3];
	int32	status;

	static char	prName_0[] = "User 0 process, EF-98     Rev. 1.00\r\n";
	static char	prName_1[] = "User 1 process, EF-98     Rev. 1.00\r\n";
	
	com_reset();
	var_reset();
	mot_reset();
	tim_reset();
	mma_reset();
		
	status = install_task(prName_0, 800, process_0);
	if (status == -1) exit(0);
	vIDProcess[0] = (uint32)status;

	status = install_task(prName_1, 800, process_1);
	if (status == -1) exit(0);
	vIDProcess[1] = (uint32)status;
}
